/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2023  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.sql;

import de.steamwar.sql.internal.Field;
import de.steamwar.sql.internal.SelectStatement;
import de.steamwar.sql.internal.Statement;
import de.steamwar.sql.internal.Table;
import lombok.AllArgsConstructor;

import java.sql.ResultSet;
import java.util.UUID;

@AllArgsConstructor
public class IgnoreSystem {

    private static final Table<IgnoreSystem> table = new Table<>(IgnoreSystem.class, "IgnoredPlayers");
    private static final SelectStatement<IgnoreSystem> select = table.select(Table.PRIMARY);
    private static final Statement insert = table.insertAll();
    private static final Statement delete = table.delete(Table.PRIMARY);

    @Field(keys = {Table.PRIMARY})
    private final int ignorer;
    @Field(keys = {Table.PRIMARY})
    private final int ignored;

    public static boolean isIgnored(UUID ignorer, UUID ignored){
        return isIgnored(SteamwarUser.get(ignorer), SteamwarUser.get(ignored));
    }

    public static boolean isIgnored(SteamwarUser ignorer, SteamwarUser ignored) {
        return select.select(ResultSet::next, ignorer.getId(), ignored.getId());
    }

    public static void ignore(SteamwarUser ignorer, SteamwarUser ignored) {
        insert.update(ignorer.getId(), ignored.getId());
    }

    public static void unIgnore(SteamwarUser ignorer, SteamwarUser ignored) {
        delete.update(ignorer.getId(), ignored.getId());
    }
}
